//
//  aria - yet another download tool
//  Copyright (C) 2000, 2001 Tatsuhiro Tsujikawa
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

// $Id: ItemCell_FTP.cc,v 1.25 2001/03/22 08:42:17 tujikawa Exp $

// class ItemCell_ftp implementation

#include "ItemCell_FTP.h"

ItemCell_FTP::ItemCell_FTP(const string& url_in,
			   const URLcontainer& urlcon_in,
			   const Options& options_in,
			   const string& initial_log)
  : ItemCell(url_in,
	     urlcon_in,
	     options_in,
	     initial_log)
{
}

ItemCell_FTP::~ItemCell_FTP()
{
}

// sock_commandϥޥѥå
// sock_waitFTPС³դѥå
void ItemCell_FTP::Get_PORT_command(const Socket& sock_command, const Socket& sock_wait, string& port_command)
{
  sockaddr_in addr_in; 
  // sock_command,ޥIPɥ쥹
  if(sock_command.Getsockname(addr_in) < 0) {
    throw ITEM_ESOCKET;
  }     
  char* ip_string = inet_ntoa(addr_in.sin_addr);
  // sock_wait,ݡֹ
  if(sock_wait.Getsockname(addr_in) < 0) {
    throw ITEM_ESOCKET;
  }
  int port = ntohs(addr_in.sin_port);
  int ipaddr[4]; 
  sscanf(ip_string, "%d.%d.%d.%d", &ipaddr[0], &ipaddr[1], &ipaddr[2], &ipaddr[3]);
  //PORTޥɤ
  port_command = "PORT "+itos(ipaddr[0])+","+
    itos(ipaddr[1])+","+
    itos(ipaddr[2])+","+
    itos(ipaddr[3])+","+
    itos(port/256)+","+
    itos(port%256)+"\r\n";
}

// send PORT command
void ItemCell_FTP::Send_port_command(const Socket& sock_command, const Socket& sock_wait)
{
  // PORTޥɤ
  string command; // PORTޥɤʸ
  string retbuf;

  Get_PORT_command(sock_command, sock_wait, command);
  Send_command(command, sock_command);

  if(Get_response(sock_command, retbuf) < 0) {// faild to send port command
    set_Command(DLERROR);
    throw ITEM_EPROT;
  }
}


//FTP active⡼
//sock_command-- ޥѤΥå
//sock_wait-- FTPС³դѤΥåȤؤΥݥ
//startingbyte-- žϥХ
Socket ItemCell_FTP::Handle_ftp_active_mode(const Socket& sock_command, unsigned int& startingbyte)
{
  string command;
  string retbuf;

  /*
  sockaddr_in serv_addr;// server(local mathine)

  memset((char*)&serv_addr, 0, sizeof(serv_addr));

  serv_addr.sin_family = AF_INET;
  serv_addr.sin_addr.s_addr = INADDR_ANY;
  serv_addr.sin_port = htons(0);

  Socket sock_wait;
  if(sock_wait.bad()) throw ITEM_EIO;
  if(sock_wait.Bind(serv_addr) < 0) {
    throw ITEM_EBIND;
  }

  if(sock_wait.Listen() < 0) {
    throw ITEM_ELISTEN;
  }

  Send_port_command(sock_command, sock_wait);
  */
  Socket sock_wait;
  connect_from(sock_command, sock_wait);
  command = "REST "+itos(startingbyte)+"\r\n";
  Send_command(command, sock_command);
  if(Get_response(sock_command, retbuf) < 0) {
    Send_message_to_gui(_("sorry, cannot resume"), MSG_DOWNLOAD_ERROR);
    startingbyte = 0;
  }

  command = "RETR "+ret_URL_Container().ret_Filename()+"\r\n";
  Send_command(command, sock_command);

  if(Get_response(sock_command, retbuf) < 0) {//faild to RETR
    set_Command(DLERROR);
    throw ITEM_EPROT;
  }
  try {
    Socket sock_data = sock_wait.Accept();
    Send_message_to_gui(_("data connection established"), MSG_DOWNLOAD_INFO);
    return sock_data;
  } catch(SocketErrorType err) {
    set_Command(DLERROR);
    throw ITEM_EPROT;
  }
}

//FTP passive⡼
//sock_command-- ޥѤΥå
//startingbyte-- žϥХ
void ItemCell_FTP::Handle_ftp_passive_mode(const Socket& sock_command, const Socket& sock_data, unsigned int& startingbyte)
{
  string report;
  string command;
  string retbuf;

  /*
  Send_command("PASV\r\n", sock_command);
  if(Get_response(sock_command, retbuf) < 0) {
    Send_message_to_gui(_("cannot enter PASV mode"), MSG_DOWNLOAD_ERROR);
    set_Command(DLERRORSTOP);
    throw ITEM_EPROT;
  }
  FTPcontainer ftpcon(retbuf);
  */
  FTPcontainer ftpcon = connect_to(sock_command);
  Make_TCP_connection(sock_data, ftpcon.ret_Port());

  command = "REST "+itos(startingbyte)+"\r\n";
  Send_command(command, sock_command);

  if(Get_response(sock_command, retbuf) < 0) {
    Send_message_to_gui(_("sorry, cannot resume"), MSG_DOWNLOAD_ERROR);
    startingbyte = 0;
  }

  set_Size_Current(startingbyte);
  command = "RETR "+ret_URL_Container().ret_Filename()+"\r\n";
  Send_command(command, sock_command);

  if(Get_response(sock_command, retbuf) < 0) {// failed to RETR
    set_Command(DLERROR);
    throw ITEM_EPROT;
  }
}

//
// FTPСΥæ
//
void ItemCell_FTP::Leave_ftp_server(const Socket& sock_command)
{
  string retbuf;

  Send_command("QUIT\r\n", sock_command);
  Get_response(sock_command, retbuf);
}

//
// ʬɤΤν
//
// divideĤʬƥ
// return:
//     false : 顼(ʬԲ)
//     true : ʬ
//
bool ItemCell_FTP::Create_partial_item_entry(unsigned int divide, unsigned int total_size)
{
  /*unsigned int downloaded_size = Get_starting_byte();
  if(downloaded_size > 0) {
    string old_filename = ret_Options().ret_Store_Dir()+ret_Filename();
    string new_filename = old_filename+".-1";
    if(rename(old_filename.c_str(), new_filename.c_str()) < 0) {
      downloaded_size = 0;
    }
    } else {
    struct stat filestat;
    string filename = ret_Options().ret_Store_Dir()+ret_Filename()+".-1";
    if(stat(filename.c_str(), &filestat) >= 0) {
      downloaded_size = filestat.st_size;
    }
    }*/
  unsigned int downloaded_size = 0;//Get_starting_byte();
  unsigned int unit, unit_reminder;
  while(1) {
    unit = (total_size-downloaded_size)/divide;
    if(unit > 0) {
      unit_reminder = (total_size-downloaded_size)%divide;
      break;
    }
    if(--divide == 1) return false;
  }
  begin_split();
  ret_Options().set_Divide(divide);
  for(unsigned int i = 0; i < divide; i++) {
    unsigned int start_range = unit*i+downloaded_size;
    unsigned int end_range;
    if(i == divide-1) {
      end_range = unit*(i+1)+downloaded_size+unit_reminder;
    } else {
      end_range = unit*(i+1)+downloaded_size;
    }
    URLcontainer urlcon_partial = ret_URL_Container();
    Options options_partial = ret_Options();
    options_partial.set_Divide(1);
    ItemCell_FTP_p *itemcell_partial = new ItemCell_FTP_p(ret_URL(),
							  urlcon_partial,
							  options_partial,
							  "created\n",
							  this,
							  i,
							  start_range,
							  end_range);
    itemcell_partial->set_Status(ITEM_READY);
    Send_partial(itemcell_partial);
    Send_message_to_gui(_("partial item added"), MSG_DOWNLOAD_INFO);
  }
  end_split();
  return true;
}

FTPcontainer ItemCell_FTP::connect_to(const Socket& sock_command) {
  string report;
  string command;
  string retbuf;

  Send_command("PASV\r\n", sock_command);
  if(Get_response(sock_command, retbuf) < 0) {
    Send_message_to_gui(_("cannot enter PASV mode"), MSG_DOWNLOAD_ERROR);
    set_Command(DLERRORSTOP);
    throw ITEM_EPROT;
  }
  FTPcontainer ftpcon(retbuf);

  return ftpcon;
}

void ItemCell_FTP::connect_from(const Socket& sock_command, const Socket& sock_wait) {
  sockaddr_in serv_addr;// server(local machine)

  memset((char*)&serv_addr, 0, sizeof(serv_addr));

  serv_addr.sin_family = AF_INET;
  serv_addr.sin_addr.s_addr = INADDR_ANY;
  serv_addr.sin_port = htons(0);


  if(sock_wait.bad()) throw ITEM_EIO;
  if(sock_wait.Bind(serv_addr) < 0) {
    throw ITEM_EBIND;
  }

  if(sock_wait.Listen() < 0) {
    throw ITEM_ELISTEN;
  }

  Send_port_command(sock_command, sock_wait);
}

bool Is_dot_dir(const string& file)
{
  if(file.empty() || file == "." || file == ".." || file == "./" || file == "../") return true;
  else return false;
}

list<ItemCell*>::const_iterator Is_in(const list<ItemCell*>& target_list, const string& target)
{
  for(list<ItemCell*>::const_iterator itr = target_list.begin(); itr != target_list.end(); ++itr) {
    if((*itr)->ret_URL() == target) return itr;
  }
  return target_list.end();
}

ItemCell* ItemCell_FTP::Make_itemcell(const string& url, const string& save_dir) {
  ItemCell *itemcell = NULL;
  URLcontainer urlcon;
  if(urlcon.Parse_URL(url)) {
    Options options_temp = ret_Options();
    options_temp.set_Store_Dir(save_dir);
    options_temp.set_FTP_recurse_count(ret_Options().ret_FTP_recurse_count()-1);
    if(urlcon.ret_Protocol() == "ftp:") {
      itemcell = new ItemCell_FTP(url, urlcon, options_temp, "created");
    } else {
      return NULL;
    }
    //itemcell->set_documentroot_dir(documentroot_dir);
    itemcell->set_root_url(ret_root_url());
  }
  return itemcell;
}

list<ItemCell*> ItemCell_FTP::Make_filelist(string lsdata)
{
  list<ItemCell*> filelist;
  list<ItemCell*> dirlist;
  while(lsdata.size()) {
    string line = Token_splitter(lsdata, "\n");
    if(line.empty()) break;
    string mode = Token_splitter(line, " \t");
    if(casecomp(mode, "total")) continue;
    string dsize = Token_splitter(line, " \t");
    string user = Token_splitter(line, " \t");
    string group = Token_splitter(line, " \t");
    string size = Token_splitter(line, " \t");
    string month = Token_splitter(line, " \t");
    string day = Token_splitter(line, " \t");
    string year_hm = Token_splitter(line, " \t");
    string fullpath;
    string savedir;
    unsigned int arrow_pos;
    bool dir_flag = false;

    try {
      if((arrow_pos = line.find("->")) != string::npos) {
	//convert link to real path
	string file;
	// ret_FTP_convet_link_to_realpath ->
	// ret_FTP_get_symlink_as_realfile
	if(!ret_Options().ret_FTP_get_symlink_as_realfile()) {
	  file = Remove_white(line.substr(arrow_pos+2));
	  string file_link = Remove_white(line.substr(0, arrow_pos));
	  // create symlink
	  if(symlink(file.c_str(), (ret_Options().ret_Store_Dir()+file_link).c_str()) < 0) {
	    string line = _("failed to create symbolic link. ignored")+':';
	    Send_message_to_gui(line+strerror(errno), MSG_DOWNLOAD_INFO);
	  }
	} else {
	  file = Remove_white(line.substr(0, arrow_pos));
	}
	if(Is_dot_dir(file)) continue;
	
	fullpath = get_abs_url(ret_URL_Container().ret_URL(), file);
	if(ret_Options().ret_FTP_no_ascend() &&
	   !ret_Options().ret_FTP_get_symlink_as_realfile() &&
	   !startwith(fullpath, ret_root_url())) {
	  continue;
	}
	get_file(file);
	savedir = get_storedir(ret_Options().ret_Store_Dir(), file);
	if(fullpath.at(fullpath.size()-1) == '/') {
	  dir_flag = true;
	}
      } else {
	string file = Remove_white(line);
	if(Is_dot_dir(file)) continue;
	if(mode.at(0) == 'd') {
	  //if no_subdir then continue
	  if(file.at(file.size()-1) != '/') {
	    file += '/';
	    dir_flag = true;
	  }
	}
	//file extention filter
	if(!dir_flag && ret_Options().ret_FTP_use_filter() &&
	   !ret_Options().Is_in_FTP_filter_target_list(file)) {
	  continue;
	}
	fullpath = get_abs_url(ret_URL_Container().ret_URL(), file);

	if(ret_Options().ret_FTP_no_ascend() &&
	   !startwith(fullpath, ret_root_url())) {
	  continue;
	}
	get_file(file);
	savedir = get_storedir(ret_Options().ret_Store_Dir(), file);
      }
      if(!ret_Options().ret_FTP_get_symlink_as_realfile()) {
	list<ItemCell*>::const_iterator itr;
	string fix;
	if(dir_flag) {
	  fix = fullpath.substr(0, fullpath.size()-1);
	} else {
	  fix = fullpath;
	}
	if((itr = Is_in(filelist, fix)) != filelist.end()) {
	  filelist.remove(*itr);
	} else {
	  if(dir_flag) {
	    fix = fullpath;
	  } else {
	    fix = fullpath+'/';
	  }
	  if((itr = Is_in(dirlist, fix)) != dirlist.end()) {
	    continue;
	  }
      }
      }
      
      if(dir_flag && ret_Options().ret_FTP_recurse_count() <= 1) {
	continue;
      }

      ItemCell *itemcell = Make_itemcell(fullpath, savedir);
      if(itemcell != NULL) {
	if(dir_flag) {
	  dirlist.push_back(itemcell);
	} else {
	  filelist.push_back(itemcell);
	}
      }
    } catch (int err) {
      // dir stack underrun
      continue;
    }
  }
  filelist.insert(filelist.end(), dirlist.begin(), dirlist.end());

  return filelist;
}

list<ItemCell*> ItemCell_FTP::Get_filelist(const Socket& sock_command)
{
  string command;
  string retbuf;

  try {
    Socket sock_data;
    switch(ret_Options().ret_FTP_Mode()) {
    case Options::FTP_ACTIVE_MODE: {
      Socket sock_wait;
      connect_from(sock_command, sock_wait);
      Send_command("LIST -l\r\n", sock_command);
      if(Get_response(sock_command, retbuf) < 0) {
	Send_message_to_gui(_("failed to list files"), MSG_DOWNLOAD_ERROR);
	set_Command(DLERRORSTOP);// fix this
	throw ITEM_EPROT;
      }
      sock_data = sock_wait.Accept();
      Send_message_to_gui(_("data connection established"), MSG_DOWNLOAD_INFO);
      break;
    }
    case Options::FTP_PASSIVE_MODE:
    default: {
      FTPcontainer ftpcon = connect_to(sock_command);
      Make_TCP_connection(sock_data, ftpcon.ret_Port());
      Send_message_to_gui(_("data connection established"), MSG_DOWNLOAD_INFO);
      Send_command("LIST -l\r\n", sock_command);
      if(Get_response(sock_command, retbuf) < 0) {
	Send_message_to_gui(_("failed to list files"), MSG_DOWNLOAD_ERROR);
	set_Command(DLERRORSTOP);// fix this
	throw ITEM_EPROT;
      }    
 
      break;
    }
    }
 
    string lsdata;
    list<int> fd_list;
    unsigned int timedout = ret_Options().ret_Timed_Out();
    while(1) {
      fd_list.clear();
      fd_list.push_back(ret_Desc_r());
      int retval = sock_data.is_readready(timedout, fd_list);
      if(retval && sock_data.is_set(fd_list)) {
	char databuf[4096];
	int size = sock_data.Recv(databuf, sizeof(databuf-1));
	if(size == 0) break;
	databuf[size] = '\0';
	lsdata += databuf;
      } else if(retval && Socket::is_set(ret_Desc_r(), fd_list)) {
	ItemCommand itemcommand;
	read(ret_Desc_r(), &itemcommand, sizeof(ItemCommand));
	set_Command(itemcommand);
	if(ret_Dl_status() != DLCHANGE) {
	  sock_data.Shutdown(2);
	  throw ITEM_EINTER;
	}
      } else {
	// timed out
	sock_data.Shutdown(2);
	throw ITEM_ETIMEDOUT;
      }
    }

    for(string::iterator itr = lsdata.begin(); itr != lsdata.end(); ++itr) {
      if(*itr == '\r') {
	*itr = ' ';
      }
    }
    Send_message_to_gui('\n'+lsdata, MSG_DOWNLOAD_RECV);
    sock_data.Shutdown(2);
    Get_response(sock_command, retbuf);
    list<ItemCell*> file_list = Make_filelist(lsdata);
    //for(list< pair<string, string> >::iterator itr = file_list.begin(); itr != file_list.end(); ++itr) {
      //cerr << itr->first << endl;
      //cerr << itr->second << endl;
    //}
    return file_list;
  } catch(SocketErrorType err) {
    set_Command(DLERROR);
    throw ITEM_EPROT;
  }
}

//extern void Send_report(MessageType reporttype, void *data);

//void ItemCell_FTP::Send_status_recursive(const list<ItemCell*>& file_dir_list)
//{
//  /*
//  if(ret_root_url().empty()) {
//   set_root_url(ret_URL_Container().ret_Protocol()+"//"+
//		 ret_URL_Container().ret_Hostname()+
//		 ret_URL_Container().ret_Dir()+'/');
//  }
//  */
//  ItemStatusFTPrec *itemstatus = new ItemStatusFTPrec(this, file_dir_list);
//  Send_report(MSG_DOWNLOAD_STATUS, itemstatus);
//}

ItemCell::DownloadStatusType ItemCell_FTP::Download_Main()
{
  unsigned int startingbyte = 0;
  string report;
  string command;
  string username;
  string password;
  string retbuf;

  if(ret_root_url().size()) {
    sleep(2);
  }
  Socket sock_command;

  try {
    /*
    if(ret_Filename().empty()) {
      Send_message_to_gui(_("file name not specified"), MSG_DOWNLOAD_ERROR);
      throw ITEM_EIO;
    }
    */

    // connection established
    if(ret_Status() != ITEM_CRCERROR &&
       ret_Status() != ITEM_EXECERROR &&
       ret_Status() != ITEM_DOWNLOAD_AGAIN &&
       ret_Options().ret_downm_type() != Options::DOWNM_NORESUME) {
      startingbyte = Get_starting_byte();
    }
    set_Status(ITEM_DOWNLOAD);
    Send_status();

    // connect to ftp server    
    if(sock_command.bad()) {
      throw ITEM_EIO;
    }

    Make_TCP_connection(sock_command, ret_URL_Container().ret_Port());

    if(Get_response(sock_command, retbuf) < 0) {//cannot connect
      set_Command(DLERROR);
      throw ITEM_EPROT;
    }

    // authentication phase
    if(ret_Options().Whether_use_authentication() &&
       ret_Options().ret_User() != "") {
      username = ret_Options().ret_User();
      password = ret_Options().ret_Password();
    } else {
      username = "anonymous";
      password = "IE40user@";
    }
    // send USER
    command = "USER "+username+"\r\n";
    Send_command(command, sock_command);
    if(Get_response(sock_command, retbuf) < 0) {
      set_Command(DLERROR);
      throw ITEM_EPROT;
    }

    // send PASS
    command = "PASS "+password+"\r\n";
    Send_command_pass(command, sock_command);
    
    if(Get_response(sock_command, retbuf) < 0) { // maybe full?
      Send_message_to_gui(_("faild to login"), MSG_DOWNLOAD_ERROR);
      set_Command(DLERROR);
      throw ITEM_EPROT;
    }

    // send TYPE command
    switch(ret_Options().ret_FTP_ret_mode()) {
    case Options::FTP_BINARY:
      Send_command("TYPE I\r\n", sock_command);
      break;
    case Options::FTP_ASCII:
    default:
      Send_command("TYPE A\r\n", sock_command);
      break;
    }
    if(Get_response(sock_command, retbuf) < 0) {
      set_Command(DLERROR);
      throw ITEM_EPROT;
    }
    // send CWD command
    if(!ret_URL_Container().ret_Dir().empty()) {
      /*
      if(ret_Options().Whether_use_authentication() &&
	 ret_Options().ret_User() != "") {
	command = "CWD ."+ret_URL_Container().ret_Dir()+"\r\n";
	} else {*/
      command = "CWD "+ret_URL_Container().ret_Dir()+"\r\n";
	//}
      Send_command(command, sock_command);
    
      if(Get_response(sock_command, retbuf) < 0) {
	Send_message_to_gui(_("specified directory is not found"), MSG_DOWNLOAD_ERROR);
	set_Command(DLERRORSTOP);
	throw ITEM_EPROT;
      }
    }

    // send LS -l %s command
    bool dirbrowse_flag = false;
    // send SIZE command
    if(ret_URL_Container().ret_Filename().empty()) {
      dirbrowse_flag = true;
    } else {
      if(startingbyte > 0 &&
	 ret_Options().ret_downm_type() == Options::DOWNM_IFMODSINCE) {
	command = "MDTM "+ret_URL_Container().ret_Filename()+"\r\n";
	Send_command(command, sock_command);
	if(Get_response(sock_command, retbuf) < 0) {
	  Send_message_to_gui(_("modtime command failed. anyway, try resume"), MSG_DOWNLOAD_INFO);
	} else {
	  time_t modtime = get_mod_time(retbuf);
	  if(Is_older_than_remote(modtime)) {
	    Send_message_to_gui(_("modification time of remote file is newer than that of local one. resume disabled"), MSG_DOWNLOAD_INFO);
	    startingbyte = 0;
	  }
	}
      }
      command = "SIZE "+ret_URL_Container().ret_Filename()+"\r\n";
      Send_command(command, sock_command);
      if(Get_response(sock_command, retbuf) < 0) {
	URLcontainer urlcon_temp = ret_URL_Container();
	//string temp_dir = ret_URL_Container().ret_File();
	ret_URL_Container().set_Dir(ret_URL_Container().ret_Dir()+ret_URL_Container().ret_File());
	ret_URL_Container().set_File("");

	if(ret_root_url().size() && ret_root_url() != ret_URL_Container().ret_Protocol()+"//"+
	   ret_URL_Container().ret_Hostname()+ret_URL_Container().ret_Dir()+'/' &&
	   ret_Options().ret_FTP_recurse_count() == 1) {
	  Send_message_to_gui(_("depth of recursion exceeded. this message can be ignored safely"), MSG_DOWNLOAD_INFO);
	  get_Options_Lock();
	  ret_Options_opt().set_Delete_When_Finish(true);
	  ret_Options_opt().set_Dont_Delete_Without_CRC(false);
	  release_Options_Lock();
	  throw ITEM_ESUCCESS;
	}
	  
	Send_message_to_gui(_("try again assuming as directory"), MSG_DOWNLOAD_INFO);
	//if(ret_Options().Whether_use_authentication() &&
	// ret_Options().ret_User() != "") {
	//  command = "CWD ."+temp_dir+"\r\n";
	//} else {
	  command = "CWD "+ret_URL_Container().ret_Dir()+"\r\n";
	  //}
	Send_command(command, sock_command);
	
	if(Get_response(sock_command, retbuf) < 0) {
	  Send_message_to_gui(_("specified directory or file is not found"), MSG_DOWNLOAD_ERROR);
	  set_URL_Container(urlcon_temp);
	  set_Command(DLERRORSTOP);
	  throw ITEM_EPROT;
	} else {
	  dirbrowse_flag = true;

	  //set_Command(DLSUCCESS);
	  //throw ITEM_ESUCCESS;
	  
	}
	/*
	  Send_message_to_gui(_("file not found"), MSG_DOWNLOAD_ERROR);
	  set_Command(DLERRORSTOP);
	  throw ITEM_EPROT;
	*/
      } else {
	if(ret_root_url().size() &&
	   ret_Options().ret_FTP_use_filter() &&
	   !ret_Options().Is_in_FTP_filter_target_list(ret_Filename())) {
	  Send_message_to_gui(_("download abort due to extention. this message can be ignored safely"), MSG_DOWNLOAD_INFO);
	  get_Options_Lock();
	  ret_Options_opt().set_Delete_When_Finish(true);
	  ret_Options_opt().set_Dont_Delete_Without_CRC(false);
	  release_Options_Lock();
	  throw ITEM_ESUCCESS;
	}
      }
    }
    if(dirbrowse_flag) {
      set_root_url(ret_URL_Container().ret_Protocol()+"//"+
		   ret_URL_Container().ret_Hostname()+
		   ret_URL_Container().ret_Dir()+'/');
      list<ItemCell*> file_dir_list = Get_filelist(sock_command);
      Send_status_recursive(file_dir_list);
      throw ITEM_ESUCCESS;
    }

    // now we know the actual size of file..
    set_Size_Total((unsigned int)atoi(retbuf.c_str()));

    if(ret_Size_Total() == startingbyte) {
      report = "'"+ret_Filename()+"'"+_(" is already downloaded");
      Send_message_to_gui(report, MSG_DOWNLOAD_INFO);

      set_Size_Current(ret_Size_Total());
      Send_status();
      Leave_ftp_server(sock_command);
      Send_message_to_gui(_("connection closed"), MSG_DOWNLOAD_INFO);

      throw ITEM_ESUCCESS;
    } else if(ret_Size_Total() < startingbyte) {
      Send_message_to_gui(_("the size of local file is larger than that of remote file. Download again"), MSG_DOWNLOAD_ERROR);
      startingbyte = 0;
    }
    if(ret_Options().ret_Divide() > 1) {
      // send REST command
      Send_message_to_gui(_("checking whether ftp server supports resuming"), MSG_DOWNLOAD_INFO);
      
      command = "REST "+itos(ret_Size_Total()/2)+"\r\n";
      Send_command(command, sock_command);
      
      if(Get_response(sock_command, retbuf) < 0) {
	Send_message_to_gui(_("sorry, cannot resume"), MSG_DOWNLOAD_ERROR);
	Send_message_to_gui(_("starting normal download instead"), MSG_DOWNLOAD_INFO);
      } else {
	//Leave_ftp_server(sock_command);
	Send_message_to_gui(_("splitting file..."), MSG_DOWNLOAD_INFO);
	if(Create_partial_item_entry(ret_Options().ret_Divide(), ret_Size_Total())) {
	  Leave_ftp_server(sock_command);
	  set_Status(ITEM_DOWNLOAD_PARTIAL);
	  Send_status();
	  set_Command(DLPARTIALSUCCESS);
	  throw ITEM_EINTER;
	} else {
	  Send_message_to_gui(_("file is too small to be devided"), MSG_DOWNLOAD_ERROR);
	  Send_message_to_gui(_("starting normal download instead"), MSG_DOWNLOAD_INFO);
	}
      }
    }

    Options::FTP_Mode ftp_mode = ret_Options().ret_FTP_Mode();

    switch(ftp_mode) {
    case Options::FTP_PASSIVE_MODE: // PASV mode
      {
	Socket sock_data;
	if(sock_data.bad()) {
	  throw ITEM_EIO;
	}
	Handle_ftp_passive_mode(sock_command, sock_data, startingbyte);
	
	Start_Download(sock_data, startingbyte);
	sock_data.Shutdown(2);
	break;
      }
    case Options::FTP_ACTIVE_MODE:
    default: //ACTIVE(NORMAL) mode
      {
	Socket sock_data = Handle_ftp_active_mode(sock_command, startingbyte);
	Start_Download(sock_data, startingbyte);
	sock_data.Shutdown(2);
	break;
      }
    }
  
    try {
      // expected reply: "226 Transfer complete."
      Get_response(sock_command, retbuf);
      
      if(!ret_Options().ret_FTP_nosend_quit()) {
	Send_command("QUIT\r\n", sock_command);
	// expected reply: "221 Goodbye." or something like this
	Get_response(sock_command, retbuf);
      }
    } catch (ItemErrorType err) {
      PERROR(err);
      Send_message_to_gui(_("an error occured, but this error can be ignored safely"), MSG_DOWNLOAD_INFO);
      throw ITEM_ESUCCESS;
    }

    throw ITEM_ESUCCESS;
  }
  catch(ItemErrorType err) {
    sock_command.Shutdown(2);
    switch(err) {
    case ITEM_ESUCCESS:
      set_Command(DLSUCCESS);
      return DLSUCCESS;
    case ITEM_EINTER:
      return ret_Command();
    case ITEM_EIOFILE:
      set_Command(DLERRORSTOP);
      PERROR(err);
      return DLERRORSTOP;
    case ITEM_EPROT://modified
      PERROR(err);
      return ret_Dl_status();
    default:
      PERROR(err);
      set_Command(DLERROR);
      return DLERROR;
    }
  }
}

//
// FTPС˥ޥɤ
//
void ItemCell_FTP::Send_command(const string& command, const Socket& sock_command)
{
  Send_message_to_gui(command, MSG_DOWNLOAD_SEND);

  SEND(command, sock_command);
}

//
// FTPС˥ޥɤ
//
// Send_commandȰ, ޥɤΰʬ*ˤɽ
void ItemCell_FTP::Send_command_pass(const string& command, const Socket& sock_command)
{
  string ast = "PASS ";
  for(unsigned int i = 0; i < command.size()-7; i++) {//fixed 2001/3/14
    ast += "*";
  }
  Send_message_to_gui(ast, MSG_DOWNLOAD_SEND);

  SEND(command, sock_command);
}

//
// FTPСα
//
// *retbufNULLǤʤȤ, åκǸιԤ˳Ǽ
// return:
//     -1: 顼
//      0: 桼ˤ
//      1: 
//
int ItemCell_FTP::Get_response(const Socket& sock_command, string& retbuf)
{
  int size;
  int retval;

  retbuf = "";

  list<int> fd_list;
  unsigned int timedout = ret_Options().ret_Timed_Out();
  string header_string;
  while(1) {
    char ch[1024];
    char *ch_tail = ch;
    fd_list.clear();
    fd_list.push_back(ret_Desc_r());
    retval = sock_command.is_readready(timedout, fd_list);
    if(retval && sock_command.is_set(fd_list)) {
      while(1) {
	size = sock_command.Recv(ch, sizeof(ch)-(ch_tail-ch), MSG_PEEK);
	
	if(size < 0) {
	  throw ITEM_ERECV;
	} else if(size == 0) {

	  if(header_string.size() < 5) {
	    //cerr << sizeof(ch)-(ch_tail-ch) << endl;
	    //cerr << header_string.size() << endl;
	    set_Command(DLERRORSTOP);
	    throw ITEM_EPROT;
	  }

	  retbuf = header_string.substr(4);
	  return 1;
	}

	int crlf_pos = 0;
	while(1) {
	  if(crlf_pos == size) break;
	  if(ch[crlf_pos] == '\r') {
	    break;
	  }
	  ++crlf_pos;
	}
	if(crlf_pos == 0) {
	  size = sock_command.Recv(ch, 2, 0);
	  header_string = "";
	  break;
	} else if(crlf_pos < size) {
	  size = sock_command.Recv(ch, crlf_pos+2, 0);
	  ch[size-2] = '\0';  
	  header_string = ch;
	  break;
	} else {
	  //ch[size] = '\0';// dangerous??
	  ch_tail = ch+size;
	}
      }
    } else if(retval && Socket::is_set(ret_Desc_r(), fd_list)) {
      ItemCommand itemcommand;
      read(ret_Desc_r(), &itemcommand, sizeof(ItemCommand));
      set_Command(itemcommand);
      if(ret_Dl_status() != DLCHANGE) {
	throw ITEM_EINTER;
      }
    } else {
      // timed out
      throw ITEM_ETIMEDOUT;
    }
    Send_message_to_gui(header_string, MSG_DOWNLOAD_RECV);
    if(isdigit(header_string[0]) && header_string[3] == ' ') {
      if(header_string[0] == '4' || header_string[0] == '5') {
	return -1;
      } else {
	break;
      }
    }
  }
  retbuf = header_string.substr(4);

  return 1;
}

//
// ե
//
// return:
//     -1: 顼
//      0: 桼ˤ
//      1: 
//
void ItemCell_FTP::Start_Download(const Socket&  sock_data, unsigned int startingbyte)
{
  ofstream outfile;
  string line;

  Make_directory_if_needed();

  try {
    line = _("starting download at ")+itos(startingbyte, true)+_("bytes");

    Send_message_to_gui(line, MSG_DOWNLOAD_INFO);

    string filename = ret_Options().ret_Store_Dir()+ret_URL_Container().ret_File();
    if(startingbyte == 0) {  // ˥
      outfile.open(filename.c_str(), ios::out|ios::trunc|ios::binary);
    } else { // 쥸塼ह
      outfile.open(filename.c_str(), ios::out|ios::app|ios::binary);
    }
    if(outfile.bad()) {
      throw ITEM_EIOFILE;
    }
    set_Size_Current(startingbyte);
    Download_data(outfile, sock_data);
    outfile.close();
  } catch (ItemErrorType err) {
    throw err;
  }
  // download successful
}
