//
//  aria - yet another download tool
//  Copyright (C) 2000, 2001 Tatsuhiro Tsujikawa
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

// $Id: ItemCell_FTP.h,v 1.9 2001/03/12 08:37:30 tujikawa Exp $

//definition of class ItemListCell

#ifndef _ITEMCELL_FTP_H_
#define _ITEMCELL_FTP_H_
#include <sys/time.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <fstream>
#include <pair.h>
#include "aria.h"
#include "FTPcontainer.h"
#include "ItemCell.h"
#include "utils.h"
using namespace std;

class ItemCell_FTP : virtual public ItemCell {
protected:
  // FTPС
  // return:
  //     -1: 顼
  //      1: 
  int Get_response(const Socket& socket, string& retbuf);

  // FTPС˥ޥcommand
  void Send_command(const string& command, const Socket& socket);

  // FTPС˥ޥcommand(ɽ*֤)
  void Send_command_pass(const string& command, const Socket& socket);

  // PORTޥɤ
  void Get_PORT_command(const Socket& sock_command, const Socket& sock_wait, string& portcommand);

  // FTPСΥæ
  void Leave_ftp_server(const Socket& sock_command);

  // PASV⡼
  void Handle_ftp_passive_mode(const Socket& sock_command, const Socket& sock_data, unsigned int& startingbyte);

  // ACTIVE⡼
  // return:
  Socket Handle_ftp_active_mode(const Socket& sock_command, unsigned int& startingbyte);

  void Start_Download(const Socket& sock_data, unsigned int startingbyte);

  // PORTޥɤ
  void Send_port_command(const Socket& sock_command, const Socket& sock_wait);

  // ʬɤν
  bool Create_partial_item_entry(unsigned int divide, unsigned int total_size);

  void connect_from(const Socket& sock_command, const Socket& sock_wait);
  FTPcontainer connect_to(const Socket& sock_command);

  list<ItemCell*> Get_filelist(const Socket& sock_command);
  list<ItemCell*> Make_filelist(string lsdata);
  ItemCell* Make_itemcell(const string& url, const string& save_dir);
  //void Send_status_recursive(const list<ItemCell*>& item_list);
public:
  // constructor
  ItemCell_FTP(const string& url,
	       const URLcontainer& urlcon,
	       const Options& options,
	       const string& initial_log
	       );
  // destructor
  virtual ~ItemCell_FTP();

  DownloadStatusType Download_Main();
};

#include "ItemCell_FTP_p.h"
#endif // _ITEMCELL_FTP_H_
