//
//  aria - yet another download tool
//  Copyright (C) 2000, 2001 Tatsuhiro Tsujikawa
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

// $Id: ItemCell_HTTP.h,v 1.17 2001/03/16 08:26:42 tujikawa Exp $

//definition of class ItemCell_HTTP

#ifndef _ITEMCELL_HTTP_H_
#define _ITEMCELL_HTTP_H_
#include <sys/time.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <ctype.h>
#include <fstream>
#include <algorithm>
#include <vector>
#include "aria.h"
#include "Base64.h"
#include "ItemCell.h"
#include "ItemList.h"
#include "UseragentList.h"
#include "HTTPcontainer.h"
#include "CookieList.h"
#include "ServerTemplateList.h"
using namespace std;

// download mode
enum DownloadMode {
  NORMAL_MODE,
  EMBEDED_URL_MODE,
  ADD_HREF_MODE
};

class ItemCell_HTTP : virtual public ItemCell {
protected:
  int session_counter;
  URLcontainer retrieved_urlcon;
  ServerTemplate svt;
  CookieList cookie_list;
  string recroot_dir;
  // եγǼ
  void Start_Download(const Socket& socket, unsigned int startingbyte);
  // GETʤɤ
  void Send_Request(const Socket& socket, unsigned int startingbyte);
  // إå
  void Get_HTTP_header(const Socket& socket, HTTPHeaderList& http_header_list);
  // ʬɤν
  bool Create_partial_item_entry(unsigned int divide, unsigned int total_size);

  string create_url(const vector<string>& string_vector);
  //string create_referer(const vector<string>& referer_vector);
public:
  // constructor
  ItemCell_HTTP(const string& url,
		const URLcontainer& urlcon,
		const Options& options,
		const string& initial_log);
  // destructor
  virtual ~ItemCell_HTTP();
  // override
  virtual DownloadStatusType Download_Main();
  void Apply_new_options();
  void set_recroot_dir(const string& recroot_dir_in);
  virtual ItemCell::DownloadStatusType Post_process();
  bool Execute_program();
};

#include "ItemCell_HTTP_p.h"
#endif // _ITEMCELL_HTTP_H_
