//
//  aria - yet another download tool
//  Copyright (C) 2000, 2001 Tatsuhiro Tsujikawa
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

// $Id: ItemCell_Partial.h,v 1.7 2001/03/09 06:49:10 tujikawa Exp $

#ifndef _ITEMCELL_PARTIAL_H_
#define _ITEMCELL_PARTIAL_H_
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include "aria.h"
#include "utils.h"
#include "ItemCell.h"

enum SplitStatusType {
  PARTIAL_NORMAL,
  PARTIAL_NOINDEX,
  PARTIAL_CHANGED
};

class ItemCell_Partial : virtual public ItemCell {
protected:
  unsigned int start_range;
  unsigned int end_range;
  unsigned int order;
  unsigned int total_size;
  string filename_partial;
  ItemCell *boss;
public:
  ItemCell_Partial(const string& url,
		   const URLcontainer& urlcon,
		   const Options& options_ptr,
		   const string& initial_log,
		   ItemCell *itemcell_parent,
		   unsigned int order,
		   unsigned int start_pos,
		   unsigned int end_pos
		   );
  virtual ~ItemCell_Partial();

  string             ret_Filename() const;
  string             ret_Filename_opt() const;
  bool               Is_Partial() const;
  unsigned int       ret_Order() const;
  DownloadStatusType Post_process();
  unsigned int       ret_Start_range() const;
  unsigned int       ret_End_range() const;

  void WriteSplitInfo(const string& filename);

  SplitStatusType SplitNumberChanged(const string& filename);
};
#endif // _ITEMCELL_PARTIAL_H_
