//
//  aria - yet another download tool
//  Copyright (C) 2000, 2001 Tatsuhiro Tsujikawa
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

// $Id: ItemStatusRec.cc,v 1.5 2001/03/12 08:37:31 tujikawa Exp $

#include "ItemStatusRec.h"

extern void Add_new_item_to_downloadlist(ItemCell *itemcell);

extern ItemManager *item_manager;
extern pthread_cond_t itemlistnotempty;
extern ItemCell *console_item;

ItemStatusRec::ItemStatusRec(ItemCell *itemcell_in,
			     const list<ItemCell *>& item_list_in
			     ) : ItemStatus(itemcell_in)
{
  item_list = item_list_in;
}

ItemStatusRec::~ItemStatusRec()
{
}

void ItemStatusRec::Update()
{  
  int count = 0;
  for(list<ItemCell *>::iterator itemcell_ptr = item_list.begin(); itemcell_ptr != item_list.end(); ++itemcell_ptr) {
    ItemCell *itemcell = *itemcell_ptr;
    if(!item_manager->search_by_url(itemcell->ret_URL_Container().ret_URL())) {
      ++count;
      Add_new_item_to_downloadlist(itemcell);
    } else {
      delete itemcell;
    }
  }
  if(count) {
    console_item->Send_message_to_gui(itos(count)+_("item(s) added"), MSG_SYS_INFO);
  }
  pthread_cond_broadcast(&itemlistnotempty);
}


