//
//  aria - yet another download tool
//  Copyright (C) 2000, 2001 Tatsuhiro Tsujikawa
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

// $Id: ThreadManager.h,v 1.9 2001/03/20 08:47:47 tujikawa Exp $

// definition of class ThreadManager

#ifndef _THREADMANAGER_H_
#define _THREADMANAGER_H_

#include <list>
#include "aria.h"
#include "ThreadSlot.h"
#include "ItemManager.h"
#include "ItemCell.h"
using namespace std;

typedef list<ThreadSlot*> ThreadList;

class ThreadManager {
private:
  unsigned int maxthread;
  bool halt_flag;
  bool autostart_flag;
  unsigned int n_thread_to_retire;
  ThreadList thread_list;//åɴꥹ
  pthread_mutex_t tm_lock;
  ThreadSlot *token_thread;
  struct timeval token_gettime;
  struct timezone tz_dummy;
  pthread_mutex_t token_lock;
public:
  ThreadManager(unsigned int maxthread);
  void ManageThread(unsigned int maxthread);
  void Wait_for_join(); // ٤ƤΥåɤνλԤ
  unsigned int How_many_Threads() const; // ꥹȤΥåɤο֤
  void Retire_thread(pthread_t thread_id); // Υåɤ򥹥åɥꥹ
                                           // 
  bool Retire_thread_if_requested(pthread_t thread_id); //Whether_retire_is_requested()+Retire_thread(...)
  bool Is_all_threads_sleeping() const;
  void Change_thread_state(pthread_t thread_id, ThreadStatusType status);
  bool Whether_halt() const;
  void set_halt_flag();
  bool Whether_retire_is_required();
  void set_retire_number(unsigned int num_of_thread_to_retire);
  ItemCell* Get_next_item();

  ThreadSlot *get_threadslot(pthread_t thread);
 
  //bool get_token(pthread_t thread);
  //bool release_token(pthread_t thread);
  //ThreadSlot *get_next_token_thread(ThreadSlot *threadslot);
};

#endif // _THREADMANAGER_H_
